package rubberWalls.Properties;

import static bp.eventSets.EventSetConstants.*;
import rubberWalls.bThreads.RoomSize;
import rubberWalls.events.Move;
import bp.BProgram;
import bp.BThread;
import bp.eventSets.EventsOfClass;
import bp.exceptions.BPJException;

@SuppressWarnings("serial")
public class DetectIllegalMoves extends BThread {
	@SuppressWarnings("static-access")
	public void runBThread() throws BPJException 
	{
		while ( true ) 
		{
			BProgram.bp.bSync(none, new EventsOfClass(Move.class), none);
			
			int x = ((Move)BProgram.bp.lastEvent).x;
			int y = ((Move)BProgram.bp.lastEvent).y;
			
			if ( 
					( y <= ( (float)(1/(2*RoomSize.ROOM_SIZE - 4)) * x + 
						2 - RoomSize.ROOM_SIZE + (float)((3-RoomSize.ROOM_SIZE )/(2*RoomSize.ROOM_SIZE  - 4) ) ) )
//						||	
//					( y >= ( ( ( 2 * RoomSize.ROOM_SIZE ) - 5 ) * x + 
//	                		(2 * RoomSize.ROOM_SIZE * RoomSize.ROOM_SIZE) - ( 8 * RoomSize.ROOM_SIZE ) + 6 ) ) 
//	                	||
//	                ( y >= ( (3.5 - RoomSize.ROOM_SIZE ) * x + 
//	                		( (float)(RoomSize.ROOM_SIZE * RoomSize.ROOM_SIZE) - (float)(RoomSize.ROOM_SIZE ) * 7.5 + 12.5 ) ) )
//                		||
//                	( y >= ( (float)(1/( 7 - 2 * RoomSize.ROOM_SIZE))* x + 
//                			RoomSize.ROOM_SIZE - 4 + (float)((RoomSize.ROOM_SIZE-2)/(7-2*RoomSize.ROOM_SIZE) ) ) )
    			)
			{
				BProgram.bp.markNextVerificationStateAsBad( "Particle reached an illegal part of the grid!" );
			}
			
			
//			if ( ( x == RoomSize.ROOM_SIZE ) || ( y == RoomSize.ROOM_SIZE ) )
//				{
//					BProgram.bp.markNextVerificationStateAsBad( "Particle reached end of grid!" );
//				}
//			int rubberZone = rubberWalls.bThreads.RoomSize.ROOM_SIZE - rubberWalls.bThreads.RoomSize.RUBBER_MARGIN;
			
//			if  ( x > rubberZone ) 
//				{
//					BProgram.bp.markNextVerificationStateAsBad( "Particle in rubber!" );
//				}

//			if ( ( x > rubberZone ) || 
//					 ( x < (-1) * rubberZone ) ||
//					 ( y > rubberZone ) ||
//					 ( y < (-1) * rubberZone ) )
//				{
//					BProgram.bp.markNextVerificationStateAsBad( "Particle in rubber!" );
//				}
		}
	}
}