package rubberWalls.bThreads;

import rubberWalls.events.Move;
import bp.eventSets.RequestableEventSet;

@SuppressWarnings("serial")
public class LeftRubberWall extends ColorChangingWall {
	public LeftRubberWall() {
		super(3);
	}

	public class BlockedPoints extends RequestableEventSet
	{
		public boolean contains(Object o) 
		{
			if ( o.getClass() == Move.class )
			{
				Move move = (Move)o;
				//return ( move.x <= (-1) * ( RoomSize.ROOM_SIZE - RoomSize.RUBBER_MARGIN ) );
				
                return move.y >= ( ( ( 2 * RoomSize.ROOM_SIZE ) - 5 ) * move.x + 
                		(2 * RoomSize.ROOM_SIZE * RoomSize.ROOM_SIZE) - ( 8 * RoomSize.ROOM_SIZE ) + 6 );

			}
			else
			{
				return super.contains( o );
			}
		}
	}

	@Override
	RequestableEventSet blockedPoints()
	{
		return new BlockedPoints();
	}
}