package rubberWalls.bThreads;

import rubberWalls.events.Move;
import bp.eventSets.RequestableEventSet;

@SuppressWarnings("serial")
public class RightRubberWall extends ColorChangingWall {	
	public RightRubberWall() 
	{
		super( 7 );
	}

	public class BlockedPoints extends RequestableEventSet
	{
		public boolean contains(Object o) 
		{
			if ( o.getClass() == Move.class )
			{
				Move move = (Move)o;
//				return ( move.x >= ( RoomSize.ROOM_SIZE - RoomSize.RUBBER_MARGIN ) );
				
				return ( move.y >= ( (3.5 - RoomSize.ROOM_SIZE ) * move.x + 
						( (float)(RoomSize.ROOM_SIZE * RoomSize.ROOM_SIZE) - (float)(RoomSize.ROOM_SIZE ) * 7.5 + 12.5 ) ) ); 
			}
			else
			{
				return super.contains( o );
			}
		}
	}

	@Override
	RequestableEventSet blockedPoints()
	{
		return new BlockedPoints();
	}
}