package rubberWalls.bThreads;

import rubberWalls.events.Move;
import bp.eventSets.RequestableEventSet;

@SuppressWarnings("serial")
public class UpRubberWall extends ColorChangingWall {	
	public UpRubberWall() {
		super(5);
	}

	public class BlockedPoints extends RequestableEventSet
	{
		public boolean contains(Object o) 
		{
			if ( o.getClass() == Move.class )
			{
				Move move = (Move)o;
				//return ( move.y >= ( RoomSize.ROOM_SIZE - RoomSize.RUBBER_MARGIN ) );
				
				return move.y >= ( (float)(1/( 7 - 2 * RoomSize.ROOM_SIZE))* move.x + 
						RoomSize.ROOM_SIZE - 4 + (float)((RoomSize.ROOM_SIZE-2)/(7-2*RoomSize.ROOM_SIZE) ) );
			}
			else
			{
				return super.contains( o );
			}
		}
	}

	@Override
	RequestableEventSet blockedPoints()
	{
		return new BlockedPoints();
	}
}