package rubberWalls.Properties;

import static bp.eventSets.EventSetConstants.*;
import rubberWalls.bThreads.RoomSize;
import rubberWalls.events.Move;
import bp.BProgram;
import bp.BThread;
import bp.eventSets.EventsOfClass;
import bp.exceptions.BPJException;

@SuppressWarnings("serial")
public class ParticleChecker extends BThread {
	@SuppressWarnings("static-access")
	public void runBThread() throws BPJException 
	{
		int lastX, lastY, x, y;
		
		lastX = 0;
		lastY = 0;
		
		while ( true ) 
		{
			BProgram.bp.bSync(none, new EventsOfClass(Move.class), none);
			
			x = ((Move)BProgram.bp.lastEvent).x;
			y = ((Move)BProgram.bp.lastEvent).y;
			
			boolean changeOnY = ( ( x == lastX ) && ( ( y == lastY + 1 ) || ( y == lastY - 1 ) ) );
			boolean changeOnX = ( ( y == lastY ) && ( ( x == lastX + 1 ) || ( x == lastX - 1 ) ) );
			
			if ( ( !changeOnX ) && ( !changeOnY ) )
			{
				BProgram.bp.markNextVerificationStateAsBad( "Particle made an illegal move!" );
			}
			
			lastX = x;
			lastY = y;
		}
	}
}