package rubberWalls.bThreads;

import static bp.BProgram.*;
import static bp.eventSets.EventSetConstants.*;

import rubberWalls.events.Move;
import bp.BProgram;
import bp.BThread;
import bp.eventSets.RequestableEventSet;
import bp.exceptions.BPJException;

@SuppressWarnings("serial")
public class AllMovements extends BThread {

	public int x;
	public int y;
	
	public void runBThread() throws BPJException, InterruptedException 
	{
		x = 0;
		y = 0;
		
		RequestableEventSet requests = new RequestableEventSet();
		RequestableEventSet allMoves = new RequestableEventSet();

		
		for ( int i = ( (-1) * RoomSize.ROOM_SIZE ) + 1 ; i < RoomSize.ROOM_SIZE; ++i )
		{
			for ( int j = ( (-1) * RoomSize.ROOM_SIZE ) + 1 ; j < RoomSize.ROOM_SIZE; ++j )
			{
				allMoves.add(new Move(i,j));
			}
		}

		requests.add( allMoves );

		while ( true )
		{
		//	labelNextVerificationState( "(" + this.x + ", " + this.y + ")");
			BProgram.bp.bSync(requests, none, none);
		
			Move move = (Move)BProgram.bp.lastEvent;
			
			this.x = move.x;
			this.y = move.y;
		}
	}
}