package rubberWalls.bThreads;

import rubberWalls.events.Move;
import bp.eventSets.RequestableEventSet;

@SuppressWarnings("serial")
public class DownRubberWall extends ColorChangingWall {

	public DownRubberWall() {
		super(2);
	}

	public class BlockedPoints extends RequestableEventSet
	{
		public boolean contains(Object o) 
		{
			if ( o.getClass() == Move.class )
			{
				Move move = (Move)o;
				//return ( move.y <= (-1) * ( RoomSize.ROOM_SIZE - RoomSize.RUBBER_MARGIN ) );
				
				return move.y <= ( (float)(1/(2*RoomSize.ROOM_SIZE - 4)) * move.x + 
						2 - RoomSize.ROOM_SIZE + (float)((3-RoomSize.ROOM_SIZE )/(2*RoomSize.ROOM_SIZE  - 4) ) );
		
			}
			else
			{
				return super.contains( o );
			}
		}
	}

	@Override
	RequestableEventSet blockedPoints()
	{
		return new BlockedPoints();
	}
}