package rubberWalls.bThreads;

import rubberWalls.bThreads.RightWall.BlockedPoints;
import rubberWalls.events.Move;
import bp.eventSets.RequestableEventSet;

@SuppressWarnings("serial")
public class LeftWall extends Wall {
	public class BlockedPoints extends RequestableEventSet
	{
		public boolean contains(Object o) 
		{
			if ( o.getClass() == Move.class )
			{
				Move move = (Move)o;
				return ( move.x < (-1) * RoomSize.ROOM_SIZE );
			}
			else
			{
				return super.contains( o );
			}
		}
	}

	@Override
	RequestableEventSet blockedPoints()
	{
		return new BlockedPoints();
	}
}