package rubberWalls.bThreads;


import rubberWalls.events.Move;
import bp.eventSets.*;
@SuppressWarnings("serial")
public class RightWall extends Wall {

	public class BlockedPoints extends RequestableEventSet
	{
		public boolean contains(Object o) 
		{
			if ( o.getClass() == Move.class )
			{
				Move move = (Move)o;
				return ( move.x > RoomSize.ROOM_SIZE );
			}
			else
			{
				return super.contains( o );
			}
		}
	}

	@Override
	RequestableEventSet blockedPoints()
	{
		return new BlockedPoints();
	}
}