package rubberWalls.bThreads;

import static bp.eventSets.EventSetConstants.*;
import bp.BProgram;
import bp.BThread;
import bp.eventSets.RequestableEventSet;
import bp.exceptions.BPJException;

@SuppressWarnings("serial")
public abstract class Wall extends BThread {

	abstract RequestableEventSet blockedPoints();
	
	public void runBThread() throws BPJException 
	{	
		RequestableEventSet illegalMoves = blockedPoints();
		
		while ( true ){
			BProgram.bp.bSync(none, none, illegalMoves);
		}
	}
}